Skip to main content
`Ctrl`+`K`

# eppstein_matching

eppstein_matching(G, top_nodes=None)

  Returns the maximum cardinality matching of the bipartite graph `G`.

  Parameters:
    G NetworkX graph

      Undirected bipartite graph

    top_nodes container

      Container with all nodes in one bipartite node set. If not supplied it will be computed. But if more than one solution exists an exception will be raised.

  Returns:
    matches dictionary

      The matching is returned as a dictionary, `matching`, such that `matching[v] == w` if node `v` is matched to node `w`. Unmatched nodes do not occur as a key in `matching`.

  Raises:
    AmbiguousSolution

      Raised if the input bipartite graph is disconnected and no container with all nodes in one bipartite set is provided. When determining the nodes in each bipartite set more than one valid solution is possible if the input graph is disconnected.

  See also

  `hopcroft_karp_matching`

  Notes

  This function is implemented with David Eppstein’s version of the algorithm Hopcroft–Karp algorithm (see `hopcroft_karp_matching()`), which originally appeared in the Python Algorithms and Data Structures library (PADS).

  See `bipartite documentation` for further details on how bipartite graphs are handled in NetworkX.